Attribute VB_Name = "ModParalelle"
Option Explicit

Public Declare Sub PortOut Lib "IO.DLL" (ByVal Port As Integer, ByVal Data As Byte)
Public Declare Function PortIn Lib "IO.DLL" (ByVal Port As Integer) As Byte
Public Declare Function IsDriverInstalled Lib "IO.DLL" () As Boolean


Public T, U, V As Integer
Public R As Single
Public RealVal(7) As Integer
Public ResultString As String
Public Compt As Integer
Public ValideLigne As String
Public BitsValideLigne As Integer
Public BitsLut As Integer
Public BitsPlusBits, BitsABits As Boolean
Public AdressLpt() As Integer
Public AdressBaseLpt As Integer
Public Sub Main()
RealVal(0) = 1: RealVal(1) = 2: RealVal(2) = 4: RealVal(3) = 8
RealVal(4) = 16: RealVal(5) = 32: RealVal(6) = 64: RealVal(7) = 128
ReDim AdressLpt(2)
AdressLpt(0) = 888: AdressLpt(1) = 632: AdressLpt(2) = 956
AdressBaseLpt = AdressLpt(0)
ValideLigne = "Null"
BitsPlusBits = False: BitsABits = False
If IsDriverInstalled = True Then
 InitialiseResetPorts
 Else
 MsgBox "impossible de trouver le driver ou le port LPT1", vbCritical
 End
End If

FrmParalelle.Show

End Sub

Public Sub InitialiseResetPorts()
'http://www.aurel32.net/elec/port_parallele.php

'--------------------------------- PC --> peripherique ----------------------------
'**** Port d'mission de donne ****, LPT1 888 = 378h, LPT2 632 = 278h, LPT3 956 = 3BC
'D0  D7
'**** port de contrle ****,          LPT1 890 = 37Ah, LPT2 634 = 27Ah, LPT3 958 = 3BE
'AUTOFED, STROBE, INIT, SELECT IN
'
'--------------------------------- peripherique --> PC -----------------------------
'**** port d'tat ****,               LPT1 889 = 379h, LPT2 633 = 279h, LPT3 957 = 3BD
'ACK, BUSY, PE, SELECT et ERROR
'bits 0  2 Inutiliss dans le mode standard
'bits 3 ERROR 0 = Erreur imprimante, 1 = Pas d'erreur
'bits 4 SELECT 0 = Imprimante OFF-LINE, 1 = Imprimante ON-LINE
'bits 5 PE 0 = Pas d'erreur, 1 = Plus de papier
'bits 6 ACK Impulsion ngative de l'imprimante pour indiquer que l'octet  t reu.
'           Attention ! Logique inverse entre le signal et la broche
'bits 7 BUSY 0 = Imprimante occupe, 1 = Imprimante prte
'---------------------------------------------------------------------------------


On Error GoTo GestErr
'PortOut 888, 0
PortOut AdressBaseLpt, 0 'mise  zero du port d'mission de donne
'AUTOFED
'PortOut 890, 13 '=ligne a 0
'PortOut 890, 15 '=ligne a 1
PortOut AdressBaseLpt + 2, 13 '=ligne a 0
PortOut AdressBaseLpt + 2, 15 '=ligne a 1
'STROBE
PortOut AdressBaseLpt + 2, 14 '=ligne a 0
PortOut AdressBaseLpt + 2, 15 '=ligne a 1
'INIT
PortOut AdressBaseLpt + 2, 11 '=ligne a 0
PortOut AdressBaseLpt + 2, 15 '=ligne a 1
'SELECT IN
PortOut AdressBaseLpt + 2, 7  '=ligne a 0
PortOut AdressBaseLpt + 2, 15 '=ligne a 1

Exit Sub
GestErr:
Beep
End Sub
Public Sub EnvoyeOctet(ValData As Integer)
On Error GoTo GestErr
'PortOut 888, ValData
PortOut AdressBaseLpt, ValData
Select Case BitsValideLigne
 Case 0
  'PortOut 888, ValData
  'ligne a 0
'  PortOut 890, 13 'AUTOFED
'  PortOut 890, 14 'STROBE
'  PortOut 890, 11 'INIT
'  PortOut 890, 7  'SELECT IN
  PortOut AdressBaseLpt + 2, 13 'AUTOFED
  PortOut AdressBaseLpt + 2, 14 'STROBE
  PortOut AdressBaseLpt + 2, 11 'INIT
  PortOut AdressBaseLpt + 2, 7  'SELECT IN
 Case Else
  'PortOut 888, ValData
'  PortOut 890, BitsValideLigne
  PortOut AdressBaseLpt + 2, BitsValideLigne
End Select
'PortOut 890, 15
PortOut AdressBaseLpt + 2, 15
Exit Sub
GestErr:
Beep
End Sub
Public Sub LitOctet()
BitsLut = PortIn(AdressBaseLpt + 1)
FrmParalelle.LabLect = BitsLut
End Sub
Public Sub Retard(DureE As Single)
FrmParalelle.ShapeSortie.FillColor = &HFF&
R = Timer + DureE
Do While R > Timer
DoEvents
Loop
FrmParalelle.ShapeSortie.FillColor = &H80FF80
End Sub
